# Dokument wizji projektu

**Niezbędnik Studenta**

**Autorzy: Anna Śniadek, Malwina Chudzińska, Adrian Pacholak, Phillip
Ławniczak**

**Data: 28.10.2020**

## 1. Wprowadzenie

Dokument dotyczy projektu realizowanego w ramach zespołowego projektu
inżynierskiego. Niniejszy dokument służy przedstawieniu przeznaczenia
tworzonego systemu, jego głównych cech i przyjętych założeń.

## 2. Cel

Celem projektu jest ułatwienie studentom Wydziału Matematyki i
Informatyki organizacji studiów. Studenci poświęcają dużo czasu na
znalezienie informacji i pomocy naukowych dotyczących danego przedmiotu,
które umieszczone są na wielu różnych portalach. Chcemy ułatwić
studentom ten proces zbierając wszystkie te materiały uporządkowane w
jednym miejscu. Platforma ma stanowić wsparcie naukowe dla studentów
porządkując pomoce naukowe dostępne w Internecie i gromadząc materiały
udostępniane przez użytkowników oraz kreować wspólną przestrzeń dla
studentów ułatwiając im integrację i jednocząc w problemach związanych
ze studiami.

## 3. Rynek

Serwis „Niezbędnik Studenta" zbiera wszystkie pomoce naukowe,
zgromadzone przez studentów oraz udostępniane przez prowadzących na
różnych portalach, w jednym miejscu.

Stanowi alternatywę dla grup tworzonych przez studentów w serwisie
„Facebook", który zbiera wiele informacji o swoich użytkownikach
zbędnych z punktu widzenia oferowanych funkcjonalności. Dodatkową
przewagą Niezbędnika Studenta jest łatwość znajdywania interesujących
nas grup oraz ich jednoznaczny podział na przedmioty, dzięki czemu posty
oraz materiały trafiają wyłącznie do grupy zainteresowanych danym
przedmiotem osób.

Informacje i materiały niezbędne dla studentów WMI są umieszczane na
wielu stronach. Nie ma natomiast miejsca w sieci zawierającego wskazówki
odnośnie wyszukiwania tych informacji ani zbierającego odnośniki do
stron, na których są one umieszczane.

Dużym atutem platformy jest fakt, że jest ona tworzona przez studentów
dla studentów, co oznacza, że rozwój aplikacji jest uzależniony od tej
jednej społeczności i ma na niego bezpośredni wpływ.

## 4. Opis produktu

-   Dostęp do serwisu dla studentów WMI po zalogowaniu w systemie
    cas.amu.edu.pl

-   Lista prowadzących i odnośniki prowadzące do ich stron

-   Lista przedmiotów nauczanych na WMI

-   Możliwość dodania się do **grupy przedmiotowej** w celu dostępu do
    **strony przedmiotu**

    -   możliwość udostępniania i korzystania z materiałów, notatek,
        przykładowych zadań wraz z rozwiązaniami -- wszystkie materiały
        dotyczące danego przedmiotu zostają zgromadzone w jednym miejscu

    -   forum dyskusyjne

    -   odnośniki do sylabusa i stron prowadzących

    -   lista prowadzących przedmiot

-   Użytkownicy mają możliwość inicjować wydarzenia w celu poszerzenia
    grupy osób do wspólnej nauki lub znalezienia osób uczących się
    samodzielnie na wydziale w celu integracji

-   Możliwość poszukiwania korepetytorów w osobnej zakładce

-   Możliwość tworzenia grup w celu znalezienia osób do zadań
    grupowych/projektów

-   Tablica ogłoszeń dla wydziału, stanowiąca miejsce na eventy, kursy,
    oferty pracy

- Pliki dodawane przez studentów będą grupowane ze względu na przedmiot,
będą filtrowane pod kątem nazwy, tagów, podział na wykład / ćwiczenia.
Użytkownicy mogą zgłosić brak przedmiotu w bazie przedmiotów jako błąd
wysyłany do administratorów. Administrator ma uprawnienia pozwalające
na zarządzanie (dodawanie / usuwanie / edycję) danymi (przedmiotami,
prowadzącymi).

- Administrator może nadawać uprawnienia administratora innym
użytkownikom.

- Administrator ma uprawnienia pozwalające na usuwanie treści (postów,
komentarzy, plików) oraz banowanie użytkowników (użytkownicy połączeni
są z kontem w Usosie). Użytkownicy mogą zgłaszać treści, które uważają
za nieodpowiednie. Komentarze do postów z kategorii zadania można
oznaczać jako proponowane odpowiedzi.

- Użytkownicy mogą oznaczać komentarze o takim charakterze jako
poprawne/niepoprawne.

## 5. Zakres i ograniczenia

W pierwszej wersji systemu po zalogowaniu w systemie cas.amu.edu.pl
dostępny będzie podstawowy interfejs startowy użytkownika, lista
przedmiotów i ich strony. Użytkownicy będą mieli możliwość dołączenia do
grup przedmiotowych, udostępniania oraz wglądu do materiałów, udziału w
forum. Ograniczenia na rozmiar udostępnianych multimediów.

-   Aplikacja webowa

-   Responsywna aplikacja dostosowana do korzystania na urządzeniach
    mobilnych

-   Technologie:

    -   Baza danych - MySQL

    -   Front-end - JavaScript, React

    -   Back-end - Java, Spring, Hibernate, JUnit

-   Ograniczenia rozmiar plików: 2 MB - jeden plik

-   Ograniczenia rozszerzeń - jpg/png, txt, pdf, docx, doc, odt