**Dokument wizji projektu**

**Nazwa projektu:**\
**\"Platforma do generowania i publikacji sprawdzianów z matematyki --
Gen-Mat\"**

**Autorzy:**

**Damian Kuich**

**Mikołaj Kowalczyk**\
**Łukasz Adam Kubiak**\
**Mateusz Michalski**

**Data: 31.10.2020**

**1. Executive summary.**

Projekt "Gen-Mat" jest to nowy serwis do generowania i publikacji
sprawdzianów z matematyki na poziomie szkół ponadpodstawowych. Generator
ma za zadanie znacznie uprościć proces tworzenia sprawdzianów, dzięki
czemu użytkownik zaoszczędzi cenny czas. Zakładamy też, że możliwość
generowania unikalnych sprawdzianów pozwoli na zmniejszenie procentu
uczniów wymieniających się odpowiedziami do zadań. Skutkiem czego będzie
bardziej sumienne przygotowywanie się do testów sprawdzających wiedzę i
umiejętności z matematyki.

**2. Cel i grupa docelowa.**

Celem projektu jest zaoszczędzenie czasu potrzebnego na własnoręczne
tworzenie sprawdzianów z matematyki. Rozwiązaniem tego problemu będzie
serwis pozwalający na automatyczne generowanie takich sprawdzianów
korzystając z gotowej i sprawdzonej bazy zadań. "Gen-Mat" jest
skierowany głównie dla nauczycieli szkół ponadpodstawowych, ponieważ w
aktualnej swej formie baza będzie zawierać tylko zadania z matur za
zgodą uzyskaną od CKE. Dotarcie do grup docelowych umożliwią nam np.
Grupy dla nauczycieli z matematyki na platformie Facebook albo
komunikacja ze zaznajomionymi szkołami ponadpodstawowymi. Głównym
produktem naszego projektu będzie aplikacja webowa, ponieważ jest to
temat w którym każdy z członków zespołu jest zaznajomiony.

**3. Rynek (min. 3 konkurencyjne produkty).**

W fazie rozwoju platforma będzie darmowym serwisem. Gdy serwis zostanie
doprowadzony do pełnej funkcjonalności przewidywana jest płatna
subskrypcja, a dla studentów uczących się na uczelniach, gdzie nasz
produkt będzie wykorzystywany, dostęp do niego będzie darmowy. Wiele
generatorów testów i sprawdzianów z matematyki (np. klasowki.pl,
kompozytorklasowek.gwo.pl, dlanauczyciela.pl/generator) jest do siebie
podobnych. Naszym zadaniem jest stworzyć system spełniający oczekiwania
klientów. Zawierałby ulepszone funkcjonalności konkurencyjnych serwisów
i dodawał nowe, które ułatwiłyby pracę z naszym serwisem i rozszerzyły
jego możliwości. Generator w odróżnieniu od istniejących serwisów
umożliwiających generowanie sprawdzianów z matematyki może na podstawie
wygenerowanych wcześniej sprawdzianów utworzyć sprawdzian poprawkowy a
także wygenerować powtórkę przed sprawdzianem, zawierającą część
praktyczną jak i teoretyczną, gdzie zadanie może zawierać podpowiedzi
np. potrzebne wzory lub sposób rozwiązania.

**4. Opis produktu (min. 3 moduły/epiki)**

-   Panel Administratora :

    -   Obszar: zarządzanie danymi, kontrola danych.

    -   Rodzaj: Administrator

-   Generator Sprawdzianów:

    -   Obszar: przetwarzanie danych

    -   Rodzaj: autoryzowany użytkownik

-   Panel Rejestracji:

    -   Obszar: przetwarzanie danych, autoryzacja

    -   Rodzaj: użytkownik o ograniczonych prawach

-   Panel Logowania:

    -   Obszar: przetwarzanie danych, autoryzacja

    -   Rodzaj: autoryzowany uzytkownik

**5. Zakres i ograniczenia.**

**5.1 Skład zespołu:**

Damian Kuich(Backend) - odpowiedzialny za wdrożenie RESTful API do
projektu i deploy aplikacji na serwer. Zajmuje się także wprowadzaniem
zadań do bazy. Preferowane technologie: Python

Mikołaj Kowalczyk(Backend) - odpowiedzialny za utworzenie bazy danych i
pomoc przy tworzeniu API. Zajmujesię także wprowadzaniem zadań do bazy.
Preferowane technologie: Python

Łukasz Kubiak(Frontend)- odpowiedzialny za funkcjonalność Frontend'u i
odbierania endpointów od Backend'u. Pomaga przy tworzeniu UI projektu.
Preferowane technologie: JavaScript

Mateusz Michalski(Frontend) - odpowiedzialny za tworzenie UI projektu.
Pomaga przy funkcjonalnościach. Preferowane technologie: JavaScript

**5.2 Kamienie milowe:**

-   **I faza, I semestr(02.2020 - 07.2020):**

    -   Przygotowanie backlogu serwisu

    -   Przygotowanie prototypu interfejsu

    -   Rozpoczęcie prac programistycznych

    -   Przygotowanie MVP serwisu

    -   Poddanie MVP testom funkcjonalnym

-   **II faza, II semestr(10.2020 - 03.2021):**

    -   Przygotowanie sprintów na drugi semestr

    -   Ukończenie prac wraz ze wszystkimi zdefiniowanymi
        funkcjonalnościami

    -   Publikacja serwisu na domenie publicznej i włączenie jej na
        serwer


**5.3 Szkic Harmonogramu:**

**Semestr I:**

-   Utworzenie konta użytkownika (logowanie i rejestracja)

-   Utworzenie bazy danych z zadaniami

-   Edycja konta użytkownika

-   Resetowanie hasła

-   Dodanie możliwości wyboru działów i umiejętności

-   Wyszukiwarka zadań

-   Ręczne tworzenie sprawdzianu

-   Podział na grupy(Dla ręcznego tworzenia)

-   Możliwość dodania obrazka

-   Prototyp generatora(Wybór: trudności zadań i ich ilości, działów i
    umiejętności)

-   Generowanie karty odpowiedzi i klucza odpowiedzi

-   Eksport sprawdzianu do PDF

**Semestr II:**

-   Edycja wygenerowanego sprawdzianu

-   Dodawanie obrazka do zadania(jpg,png)

-   Miejsce pod zadaniem

-   Dodawanie własnych zadań

-   Edycja dodanych zadań

-   Ustawienie zadań na prywatne/publiczne

-   Możliwość udostępniania swoich zadań innym nauczycielom

-   Możliwość oszacowania czasu na rozwiązanie zadania

-   Edytor równań

-   Postawienie strony na serwerze

-   Dodanie publicznej domeny

**5.4 Ograniczenia:**

W pierwszej fazie projektu, produkt oferować będzie ograniczoną ilość
działów, co za tym idzie ograniczoną ilość umiejętności potrzebnych do
rozwiązania zadania i zadań z powodu praw autorskich. Możliwa będzie
edycja wyłącznie zadań dodanych przez użytkowników (jeżeli autor zadania
wyrazi na to zgodę). Do tej pory udało nam się otrzymać pozwolenie od
CKE na korzystanie z ich zadań, jednakże pod dwoma warunkami: brak
możliwości edycji zadań oraz obowiązkowe podanie autora zadania wraz z
zasadami oceniania. Możliwy będzie wybór trudności zadań wraz z ich
liczbą, podział na grupy (maks. 4), edytowanie i eksport sprawdzianu do
pdf, ustalenie punktacji do zadań, możliwość stworzenia własnego
sprawdzianu. Będzie możliwość stworzenia konta użytkownika i jego edycji
ale nie będzie posiadał możliwości uwierzytelniania czy osoba jest
uprawniona do używania serwisu.
