# **Dokument wizji projektu**

**Nazwa projektu: Platformowa gra w Unity**

**Autorzy: Kamil Tyrek, Mateusz Hypś, Jakub Kozubal**

**Data: 15.11.2020 r.**

**1. Executive summary (max. 150 słów)**

Projekt ma na celu stworzenie gry platformowej, której celem będzie zapewnienie graczom rozrywki. Przechodzenie kolejnych etapów gry wymaga zręczności i szybkiego podejmowanie decyzji, dzięki czemu rozgrywka jest ciekawsza i może zaciekawić użytkownika. Grupą docelową jest każda osoba, która chce dobrze spędzić czas. Nie jest wymagana umiejętność czy doświadczenie gracza, gdyż gra wprowadza użytkownika do świata rozgrywki poprzez poziom samouczka. Zyski z gry będą wynikać z korzystania z platformy itch.io, która pozwoli na sprzedaż gry oraz jej aktualizowanie. Portal pozwala na darmowe udostępnienie gry. Ryzykiem jest brak zainteresowania produktem, czego skutkiem będzie brak zysku. Podczas rozgrywki użytkownik będzie walczył z wrogami, wchodził w interakcje z obiektami, rozwiązywał łamigłówki oraz mini-gry.

**2. Cel i grupa docelowa (min. 150 słów)**

Celem produktu jest zapewnienie rozrywki dla klienta. Klient, korzystając z naszego produktu, zostanie wprowadzony w świat gry, zostanie mu przedstawiona mechanika gry poprzez samouczek, który będzie przedstawiał kolejne funkcjonalności produktu. Użytkownik w czasie przechodzenia kolejnych etapów będzie musiał wykazywać się zręcznością oraz szybkim podejmowaniem decyzji. W czasie rozgrywki będzie musiał pokonywać między innymi zapadające się pod nim platformy, poruszające się platformy, rozwiązywać łamigłówki, czy też pokonywać mini-gry, których wykonanie nie zawsze będzie obowiązkowe. Wszystkie te aspekty zapewniają, że gra nie polega na prostym przechodzeniu kolejnych etapów i pokonywania wrogów, przez co rozgrywka bardziej wciąga i jest ciekawsza. Grupy docelowe można podzielić na dwie podgrupy: doświadczonych graczy i niedoświadczonych. Pierwsza grupa nie będzie miała problemów z początkową rozgrywką. Nasz produkt, jeśli chodzi o mechanikę, nie wyróżnia się znacznie od innych tego typu gier. Różnice polegają na dodaniu nietypowych elementów, które pojawiają się w czasie przechodzenia etapów, takie jak mini-gry. Drugą grupą są osoby niedoświadczone. Dla takich osób przygotowane jest wprowadzenie – poziom 0. Podczas poziomu dla użytkownika przekazywane są informacje o mechanikach i możliwościach gry. Pozwala to na zaznajomienie się z produktem. Komunikaty są jasne i przedstawione w sposób zrozumiały.

Chcemy dotrzeć do klientów umieszczając go na platformie itch.io. Jest to platforma z grami typu indie. Umieszczenie tej gry na tej platformie pozwoli na łatwiejszy dostęp do niej oraz możliwość aktualizacji gry przez zespół deweloperski w dowolnym momencie. Ułatwi też kontakt z klientem, który będzie mógł zgłaszać błędy, które wyniknęłyby w trakcie rozgrywki.

**3. Rynek (min. 3 konkurencyjne produkty)**

Hollow Knight – Dwuwymiarowa przygodowa gra akcji. Została wyprodukowana przez Team Cherry i wydana w 2017 roku. Gra ta również polega na ratowaniu świata, w tym wypadku przed infekcją bestii. Gra wyróżnia się głównie ręcznie malowanymi sceneriami, które bardzo dobrze trzymają w klimacie. Nasza gra nie posiada wielu ręcznie rysowanych elementów, za to wyróżnia się elementami logicznymi, na które napotyka się użytkownik w trakcie przechodzenia gry.

Super Meat Boy – Dwuwymiarowa gra zręcznościowa wydana w 2011 roku przez Team Meat. Gra opiera się głównie na elementach zręcznościowych i szybkiej rozgrywce gdyż każdy poziom ma określony czas w którym należy go przejść. Nasza gra wyróżnia się fabułą, która w Super Meat Boy jest dużo bardziej uboga. Super Meat Boy poza elementami zręcznościowymi i mapami tematycznymi do danego etapu gry nie ma za dużo elementów pobocznych w rozgrywce.

Ori and the blind forest – Dwuwymiarowa gra przygodowa wydana przez studio Microsoft Games. Gra wyróżnia się bardzo starannie ręcznie rysowanymi elementami, fabułą jak i bardzo rozbudowaną rozgrywką. W grze występują również elementy logiczne, dużo pobocznych zadań i zdobywanie nowych umiejętności.

**4. Opis produktu (min. 3 moduły/epiki)**

- Moduł głównego menu:
    - Rozpoczęcie nowej gry
    - Wczytanie gry z ostatniego zapisu
    - Dostosowanie:
      - rozdzielczości
      - poziomu jasności gry
      -  głośności muzyki i efektów
    - Włączenie opcji synchronizacji pionowej
    - Przełączanie między trybem pełnego ekranu z okienkowym
    - Możliwość zmiany domyślnie przypisanych klawiszy sterownia
    - Wyjście z gry do pulpitu
    - Animowane tło
  - Obszar: Konfiguracja ustawień, Przetwarzanie danych,
  - Rodzaj: Użytkownicy
- Moduł mini-gier:
  - Obszar: puzzle, rury, otwieranie skarbu
    - Wyjście z mini-gry
    - Możliwość restartu puzzli
  - Rodzaj: Użytkownicy
- Moduł poziomów:
  - Obszar: poziom samouczkowy, poziom 1, poziom do wyborów poziomów:
    - Możliwość przejścia do następnego poziomu
    - Odpalenie łamigłówek z interakcją kamery
    - Walka z wrogami
  - Rodzaj: Użytkownicy

**5. Zakres i ograniczenia**

- **Semestr 1**
  - Przygotowanie prototypu interfejsu
  - Przygotowanie backlogu dla projektu projektu w systemie JIRA, opracowanie funkcjonalności, user stories
  - Testy użyteczności interfejsu
  - Przygotowanie wersji demonstracyjnej gry z dwoma poziomami
- **Semestr 2**
  - Rozwinięcie poziomu pierwszego, którego średni czas przejścia będzie trwał 18 minut, licząc walki z ostatecznym przeciwnikiem – koniec listopada
  - Utworzenie systemu rozwoju umiejętności (drzewko umiejętności) – koniec grudnia
  - Wdrożenie aplikacji do platformy z grami – koniec grudnia
  - Ukończenie aplikacji wraz z zapowiedzianymi funkcjonalnościami – koniec stycznia
- Zespół:

a) Mateusz Hypś

§ Projektowanie architektury gry

§ Tworzenie dokumentacji

§ Implementacja produktu końcowego

b) Jakub Kozubal

§ Projektowanie architektury gry

§ Tworzenie dokumentacji

§ Implementacja produktu końcowego

§ Nadzorowanie testów

c) Kamil Tyrek

§ Projektowanie architektury gry

§ Tworzenie dokumentacji

§ Tworzenie prototypu opcji

§ Nadzorowanie testów

§ Nadzorowanie przebiegiem sprintów – zakładanie zadań, zarządzanie spotkań cotygodniowych

**Harmonogram na semestr II:**

- **Listopad**
  - Poziom do wyboru poziomów
  - Ekwipunek postaci
  - Otwieranie skrzyń – mini-gra
  - Rozwój poziomu 1 o nowe funkcjonalności, rozszerzenie mapy
  - Stworzenie przeciwnika o rozwiniętych mechanikach, typu boss
- **Grudzień**
  - Stworzenie drzewka umiejętności opartego o trzy gałęzie
- **Styczeń**
  - Stworzenie poziomu do walki z wrogami – fale wrogów, z biegiem czasu przychodzi więcej przeciwników